sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"About Components","anchor":"about-components"},{"id":"Overview","anchor":"overview"},{"id":"Overview","anchor":"overview"},{"id":"Exceptions","anchor":"exceptions"},{"id":"Mix Tasks","anchor":"mix-tasks"}]},{"id":"welcome","title":"Scenic","group":"","headers":[{"id":"How to get started?","anchor":"how-to-get-started"}]},{"id":"install_dependencies","title":"Install Dependencies","group":"","headers":[]},{"id":"overview_general","title":"General Overview","group":"","headers":[{"id":"Goals","anchor":"goals"},{"id":"Non-Goals","anchor":"non-goals"},{"id":"Architecture","anchor":"architecture"},{"id":"Mental Model","anchor":"mental-model"},{"id":"Terms and Definitions","anchor":"terms-and-definitions"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"getting_started","title":"Getting Started","group":"","headers":[{"id":"Install scenic.new","anchor":"install-scenic-new"},{"id":"Build the Starter App","anchor":"build-the-starter-app"},{"id":"Configure Scenic","anchor":"configure-scenic"},{"id":"Running and Debugging","anchor":"running-and-debugging"},{"id":"The Starter App","anchor":"the-starter-app"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"getting_started_nerves","title":"getting_started_nerves","group":"","headers":[]},{"id":"overview_scene","title":"Structure of a Scene","group":"","headers":[{"id":"The Graph","anchor":"the-graph"},{"id":"Initialization","anchor":"initialization"},{"id":"Pushing a Graph","anchor":"pushing-a-graph"},{"id":"User Input","anchor":"user-input"},{"id":"Events","anchor":"events"},{"id":"Components","anchor":"components"},{"id":"Adding Components to a Parent Scene","anchor":"adding-components-to-a-parent-scene"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"scene_lifecycle","title":"Life-cycle of a Scene","group":"","headers":[{"id":"The Root Scene","anchor":"the-root-scene"},{"id":"Dynamically Supervised Scenes","anchor":"dynamically-supervised-scenes"},{"id":"App Supervised Scenes","anchor":"app-supervised-scenes"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_graph","title":"Graph Overview","group":"","headers":[{"id":"Primitives","anchor":"primitives"},{"id":"Styles","anchor":"styles"},{"id":"Transforms","anchor":"transforms"},{"id":"Modifying a graph","anchor":"modifying-a-graph"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_viewport","title":"ViewPort Overview","group":"","headers":[]},{"id":"overview_driver","title":"Driver Overview","group":"","headers":[]},{"id":"overview_styles","title":"Styles Overview","group":"","headers":[{"id":"Primitive Styles","anchor":"primitive-styles"},{"id":"Primitive Paint Styles","anchor":"primitive-paint-styles"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_transforms","title":"Transforms Overview","group":"","headers":[{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_primitives","title":"Primitives Overview","group":"","headers":[{"id":"Using Primitives","anchor":"using-primitives"},{"id":"Styles","anchor":"styles"},{"id":"Transforms","anchor":"transforms"},{"id":"Modifying a Primitive","anchor":"modifying-a-primitive"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"code_of_conduct","title":"Contributor Code of Conduct","group":"","headers":[]},{"id":"contributing","title":"Contributing to Scenic","group":"","headers":[{"id":"Components","anchor":"components"},{"id":"Using the issue tracker","anchor":"using-the-issue-tracker"},{"id":"Bug reports","anchor":"bug-reports"},{"id":"Feature requests","anchor":"feature-requests"},{"id":"Contributing Documentation","anchor":"contributing-documentation"},{"id":"Pull requests","anchor":"pull-requests"},{"id":"Guides","anchor":"guides"}]}],"exceptions":[{"id":"Scenic.Cache.Error","title":"Scenic.Cache.Error","group":""},{"id":"Scenic.Cache.Hash.Error","title":"Scenic.Cache.Hash.Error","group":""},{"id":"Scenic.Component.Error","title":"Scenic.Component.Error","group":""},{"id":"Scenic.Graph.Error","title":"Scenic.Graph.Error","group":""},{"id":"Scenic.Primitive.Error","title":"Scenic.Primitive.Error","group":""},{"id":"Scenic.Primitive.Style.FormatError","title":"Scenic.Primitive.Style.FormatError","group":""},{"id":"Scenic.Primitive.Transform.FormatError","title":"Scenic.Primitive.Transform.FormatError","group":""},{"id":"Scenic.ViewPort.Driver.Error","title":"Scenic.ViewPort.Driver.Error","group":""}],"modules":[{"id":"Scenic","title":"Scenic","group":""},{"id":"Scenic.Components","title":"Scenic.Components","group":"","functions":[{"id":"button/3","anchor":"button/3"},{"id":"checkbox/3","anchor":"checkbox/3"},{"id":"dropdown/3","anchor":"dropdown/3"},{"id":"radio_group/3","anchor":"radio_group/3"},{"id":"slider/3","anchor":"slider/3"},{"id":"text_field/3","anchor":"text_field/3"},{"id":"toggle/3","anchor":"toggle/3"}]},{"id":"Scenic.Graph","title":"Scenic.Graph","group":"","functions":[{"id":"add/2","anchor":"add/2"},{"id":"add/4","anchor":"add/4"},{"id":"build/1","anchor":"build/1"},{"id":"count/1","anchor":"count/1"},{"id":"count/2","anchor":"count/2"},{"id":"delete/2","anchor":"delete/2"},{"id":"get!/2","anchor":"get!/2"},{"id":"get/2","anchor":"get/2"},{"id":"get_root/1","anchor":"get_root/1"},{"id":"map/2","anchor":"map/2"},{"id":"map/3","anchor":"map/3"},{"id":"modify/3","anchor":"modify/3"},{"id":"reduce/3","anchor":"reduce/3"},{"id":"reduce/4","anchor":"reduce/4"}],"types":[{"id":"key/0","anchor":"t:key/0"},{"id":"t/0","anchor":"t:t/0"}]},{"id":"Scenic.Primitives","title":"Scenic.Primitives","group":"","functions":[{"id":"arc/3","anchor":"arc/3"},{"id":"circle/3","anchor":"circle/3"},{"id":"ellipse/3","anchor":"ellipse/3"},{"id":"group/3","anchor":"group/3"},{"id":"line/3","anchor":"line/3"},{"id":"path/3","anchor":"path/3"},{"id":"quad/3","anchor":"quad/3"},{"id":"rect/3","anchor":"rect/3"},{"id":"rectangle/3","anchor":"rectangle/3"},{"id":"rounded_rectangle/3","anchor":"rounded_rectangle/3"},{"id":"rrect/3","anchor":"rrect/3"},{"id":"scene_ref/3","anchor":"scene_ref/3"},{"id":"sector/3","anchor":"sector/3"},{"id":"text/3","anchor":"text/3"},{"id":"triangle/3","anchor":"triangle/3"},{"id":"update_opts/2","anchor":"update_opts/2"}]},{"id":"Scenic.Scene","title":"Scenic.Scene","group":"","callbacks":[{"id":"filter_event/3","anchor":"c:filter_event/3"},{"id":"handle_input/3","anchor":"c:handle_input/3"},{"id":"init/2","anchor":"c:init/2"}],"functions":[{"id":"cast/2","anchor":"cast/2"},{"id":"cast_to_refs/2","anchor":"cast_to_refs/2"},{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_cast/2","anchor":"handle_cast/2"},{"id":"send_event/2","anchor":"send_event/2"}],"types":[{"id":"ref/0","anchor":"t:ref/0"}]},{"id":"Scenic.ViewPort","title":"Scenic.ViewPort","group":"","functions":[{"id":"capture_input/2","anchor":"capture_input/2"},{"id":"driver_cast/2","anchor":"driver_cast/2"},{"id":"info/1","anchor":"info/1"},{"id":"input/2","anchor":"input/2"},{"id":"input/3","anchor":"input/3"},{"id":"release_input/2","anchor":"release_input/2"},{"id":"request_root/2","anchor":"request_root/2"},{"id":"reshape/2","anchor":"reshape/2"},{"id":"set_root/3","anchor":"set_root/3"},{"id":"start/1","anchor":"start/1"},{"id":"stop/1","anchor":"stop/1"}],"types":[{"id":"event/0","anchor":"t:event/0"}]},{"id":"Scenic.ViewPort.Status","title":"Scenic.ViewPort.Status","group":"","types":[{"id":"t/0","anchor":"t:t/0"}]},{"id":"Scenic.Component","title":"Scenic.Component","group":"Components","callbacks":[{"id":"add_to_graph/3","anchor":"c:add_to_graph/3"},{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}]},{"id":"Scenic.Component.Button","title":"Scenic.Component.Button","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.Caret","title":"Scenic.Component.Input.Caret","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.Checkbox","title":"Scenic.Component.Input.Checkbox","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.Dropdown","title":"Scenic.Component.Input.Dropdown","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.RadioButton","title":"Scenic.Component.Input.RadioButton","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.RadioGroup","title":"Scenic.Component.Input.RadioGroup","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.Slider","title":"Scenic.Component.Input.Slider","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.TextField","title":"Scenic.Component.Input.TextField","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Component.Input.Toggle","title":"Scenic.Component.Input.Toggle","group":"Components","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"init/2","anchor":"init/2"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive","title":"Scenic.Primitive","group":"Primitives","callbacks":[{"id":"add_to_graph/3","anchor":"c:add_to_graph/3"},{"id":"contains_point?/2","anchor":"c:contains_point?/2"},{"id":"default_pin/1","anchor":"c:default_pin/1"},{"id":"expand/1","anchor":"c:expand/1"},{"id":"filter_styles/1","anchor":"c:filter_styles/1"},{"id":"info/1","anchor":"c:info/1"},{"id":"valid_styles/0","anchor":"c:valid_styles/0"},{"id":"verify/1","anchor":"c:verify/1"}],"functions":[{"id":"build/3","anchor":"build/3"},{"id":"contains_point?/2","anchor":"contains_point?/2"},{"id":"delete_style/2","anchor":"delete_style/2"},{"id":"delete_transform/2","anchor":"delete_transform/2"},{"id":"do_put/2","anchor":"do_put/2"},{"id":"get/1","anchor":"get/1"},{"id":"get_style/3","anchor":"get_style/3"},{"id":"get_styles/1","anchor":"get_styles/1"},{"id":"get_transform/3","anchor":"get_transform/3"},{"id":"get_transforms/1","anchor":"get_transforms/1"},{"id":"put/3","anchor":"put/3"},{"id":"put_opts/2","anchor":"put_opts/2"},{"id":"put_style/2","anchor":"put_style/2"},{"id":"put_style/3","anchor":"put_style/3"},{"id":"put_styles/2","anchor":"put_styles/2"},{"id":"put_transform/2","anchor":"put_transform/2"},{"id":"put_transform/3","anchor":"put_transform/3"},{"id":"put_transforms/2","anchor":"put_transforms/2"}],"types":[{"id":"t/0","anchor":"t:t/0"}]},{"id":"Scenic.Primitive.Arc","title":"Scenic.Primitive.Arc","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Circle","title":"Scenic.Primitive.Circle","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Ellipse","title":"Scenic.Primitive.Ellipse","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Group","title":"Scenic.Primitive.Group","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"delete/2","anchor":"delete/2"},{"id":"get/1","anchor":"get/1"},{"id":"increment/2","anchor":"increment/2"},{"id":"info/1","anchor":"info/1"},{"id":"insert_at/3","anchor":"insert_at/3"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Line","title":"Scenic.Primitive.Line","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"centroid/1","anchor":"centroid/1"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Path","title":"Scenic.Primitive.Path","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Quad","title":"Scenic.Primitive.Quad","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"expand/2","anchor":"expand/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Rectangle","title":"Scenic.Primitive.Rectangle","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"centroid/1","anchor":"centroid/1"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.RoundedRectangle","title":"Scenic.Primitive.RoundedRectangle","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"centroid/1","anchor":"centroid/1"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.SceneRef","title":"Scenic.Primitive.SceneRef","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Sector","title":"Scenic.Primitive.Sector","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Text","title":"Scenic.Primitive.Text","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Triangle","title":"Scenic.Primitive.Triangle","group":"Primitives","functions":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"},{"id":"build/2","anchor":"build/2"},{"id":"centroid/1","anchor":"centroid/1"},{"id":"get/1","anchor":"get/1"},{"id":"info/1","anchor":"info/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style","title":"Scenic.Primitive.Style","group":"Styles","callbacks":[{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}],"functions":[{"id":"normalize/2","anchor":"normalize/2"},{"id":"primitives/1","anchor":"primitives/1"},{"id":"verify!/2","anchor":"verify!/2"},{"id":"verify/2","anchor":"verify/2"}]},{"id":"Scenic.Primitive.Style.Cap","title":"Scenic.Primitive.Style.Cap","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.ClearColor","title":"Scenic.Primitive.Style.ClearColor","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Fill","title":"Scenic.Primitive.Style.Fill","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Font","title":"Scenic.Primitive.Style.Font","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.FontBlur","title":"Scenic.Primitive.Style.FontBlur","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.FontSize","title":"Scenic.Primitive.Style.FontSize","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Hidden","title":"Scenic.Primitive.Style.Hidden","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Join","title":"Scenic.Primitive.Style.Join","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.MiterLimit","title":"Scenic.Primitive.Style.MiterLimit","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Scissor","title":"Scenic.Primitive.Style.Scissor","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Stroke","title":"Scenic.Primitive.Style.Stroke","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.TextAlign","title":"Scenic.Primitive.Style.TextAlign","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.TextHeight","title":"Scenic.Primitive.Style.TextHeight","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Theme","title":"Scenic.Primitive.Style.Theme","group":"Styles","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"preset/1","anchor":"preset/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Paint","title":"Scenic.Primitive.Style.Paint","group":"Style.Paint","functions":[{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Paint.BoxGradient","title":"Scenic.Primitive.Style.Paint.BoxGradient","group":"Style.Paint","functions":[{"id":"normalize/1","anchor":"normalize/1"}]},{"id":"Scenic.Primitive.Style.Paint.Color","title":"Scenic.Primitive.Style.Paint.Color","group":"Style.Paint","functions":[{"id":"name_to_rgb/1","anchor":"name_to_rgb/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"to_rgba/1","anchor":"to_rgba/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Style.Paint.Image","title":"Scenic.Primitive.Style.Paint.Image","group":"Style.Paint","functions":[{"id":"normalize/1","anchor":"normalize/1"}]},{"id":"Scenic.Primitive.Style.Paint.LinearGradient","title":"Scenic.Primitive.Style.Paint.LinearGradient","group":"Style.Paint","functions":[{"id":"normalize/1","anchor":"normalize/1"}]},{"id":"Scenic.Primitive.Style.Paint.RadialGradient","title":"Scenic.Primitive.Style.Paint.RadialGradient","group":"Style.Paint","functions":[{"id":"normalize/1","anchor":"normalize/1"}]},{"id":"Scenic.Primitive.Transform","title":"Scenic.Primitive.Transform","group":"Transforms","callbacks":[{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}],"functions":[{"id":"calculate_local/1","anchor":"calculate_local/1"},{"id":"verify!/2","anchor":"verify!/2"}]},{"id":"Scenic.Primitive.Transform.Matrix","title":"Scenic.Primitive.Transform.Matrix","group":"Transforms","functions":[{"id":"info/1","anchor":"info/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Transform.Pin","title":"Scenic.Primitive.Transform.Pin","group":"Transforms","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Transform.Rotate","title":"Scenic.Primitive.Transform.Rotate","group":"Transforms","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Transform.Scale","title":"Scenic.Primitive.Transform.Scale","group":"Transforms","functions":[{"id":"info/0","anchor":"info/0"},{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Primitive.Transform.Translate","title":"Scenic.Primitive.Transform.Translate","group":"Transforms","functions":[{"id":"info/1","anchor":"info/1"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"verify!/1","anchor":"verify!/1"},{"id":"verify/1","anchor":"verify/1"}]},{"id":"Scenic.Math","title":"Scenic.Math","group":"Math","types":[{"id":"line/0","anchor":"t:line/0"},{"id":"matrix/0","anchor":"t:matrix/0"},{"id":"matrix_list/0","anchor":"t:matrix_list/0"},{"id":"point/0","anchor":"t:point/0"},{"id":"quad/0","anchor":"t:quad/0"},{"id":"triangle/0","anchor":"t:triangle/0"},{"id":"vector_2/0","anchor":"t:vector_2/0"}]},{"id":"Scenic.Math.Line","title":"Scenic.Math.Line","group":"Math","functions":[{"id":"intersection/2","anchor":"intersection/2"},{"id":"parallel/2","anchor":"parallel/2"},{"id":"round/1","anchor":"round/1"},{"id":"trunc/1","anchor":"trunc/1"}]},{"id":"Scenic.Math.Matrix","title":"Scenic.Math.Matrix","group":"Math","functions":[{"id":"add/2","anchor":"add/2"},{"id":"adjugate/1","anchor":"adjugate/1"},{"id":"build_rotate_around/2","anchor":"build_rotate_around/2"},{"id":"build_rotation/1","anchor":"build_rotation/1"},{"id":"build_scale/1","anchor":"build_scale/1"},{"id":"build_translation/1","anchor":"build_translation/1"},{"id":"close?/3","anchor":"close?/3"},{"id":"determinant/1","anchor":"determinant/1"},{"id":"div/2","anchor":"div/2"},{"id":"get/3","anchor":"get/3"},{"id":"get_xy/1","anchor":"get_xy/1"},{"id":"identity/0","anchor":"identity/0"},{"id":"invert/1","anchor":"invert/1"},{"id":"mul/1","anchor":"mul/1"},{"id":"mul/2","anchor":"mul/2"},{"id":"project_vector/2","anchor":"project_vector/2"},{"id":"project_vectors/2","anchor":"project_vectors/2"},{"id":"put/4","anchor":"put/4"},{"id":"rotate/2","anchor":"rotate/2"},{"id":"scale/2","anchor":"scale/2"},{"id":"sub/2","anchor":"sub/2"},{"id":"translate/2","anchor":"translate/2"},{"id":"transpose/1","anchor":"transpose/1"},{"id":"zero/0","anchor":"zero/0"}]},{"id":"Scenic.Math.Matrix.Utils","title":"Scenic.Math.Matrix.Utils","group":"Math","functions":[{"id":"to_binary/1","anchor":"to_binary/1"},{"id":"to_list/1","anchor":"to_list/1"}]},{"id":"Scenic.Math.Quad","title":"Scenic.Math.Quad","group":"Math","functions":[{"id":"classification/1","anchor":"classification/1"}],"types":[{"id":"classification/0","anchor":"t:classification/0"}]},{"id":"Scenic.Math.Vector2","title":"Scenic.Math.Vector2","group":"Math","functions":[{"id":"add/2","anchor":"add/2"},{"id":"clamp/3","anchor":"clamp/3"},{"id":"cross/2","anchor":"cross/2"},{"id":"distance/2","anchor":"distance/2"},{"id":"distance_squared/2","anchor":"distance_squared/2"},{"id":"div/2","anchor":"div/2"},{"id":"dot/2","anchor":"dot/2"},{"id":"down/0","anchor":"down/0"},{"id":"in_bounds?/2","anchor":"in_bounds?/2"},{"id":"in_bounds?/3","anchor":"in_bounds?/3"},{"id":"invert/1","anchor":"invert/1"},{"id":"left/0","anchor":"left/0"},{"id":"length/1","anchor":"length/1"},{"id":"length_squared/1","anchor":"length_squared/1"},{"id":"lerp/3","anchor":"lerp/3"},{"id":"max/2","anchor":"max/2"},{"id":"min/2","anchor":"min/2"},{"id":"mul/2","anchor":"mul/2"},{"id":"nlerp/3","anchor":"nlerp/3"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"one/0","anchor":"one/0"},{"id":"project/2","anchor":"project/2"},{"id":"right/0","anchor":"right/0"},{"id":"round/1","anchor":"round/1"},{"id":"sub/2","anchor":"sub/2"},{"id":"trunc/1","anchor":"trunc/1"},{"id":"unity_x/0","anchor":"unity_x/0"},{"id":"unity_y/0","anchor":"unity_y/0"},{"id":"up/0","anchor":"up/0"},{"id":"zero/0","anchor":"zero/0"}]},{"id":"Scenic.ViewPort.Config","title":"Scenic.ViewPort.Config","group":"ViewPort","functions":[{"id":"valid!/1","anchor":"valid!/1"},{"id":"valid?/1","anchor":"valid?/1"}],"types":[{"id":"t/0","anchor":"t:t/0"}]},{"id":"Scenic.ViewPort.Context","title":"Scenic.ViewPort.Context","group":"ViewPort","functions":[{"id":"build/1","anchor":"build/1"}],"types":[{"id":"t/0","anchor":"t:t/0"}]},{"id":"Scenic.ViewPort.Tables","title":"Scenic.ViewPort.Tables","group":"ViewPort","functions":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"delete_graph/1","anchor":"delete_graph/1"},{"id":"get_graph/1","anchor":"get_graph/1"},{"id":"get_graph_refs/1","anchor":"get_graph_refs/1"},{"id":"get_refs/1","anchor":"get_refs/1"},{"id":"insert_graph/4","anchor":"insert_graph/4"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]},{"id":"Scenic.ViewPort.Driver","title":"Scenic.ViewPort.Driver","group":"Drivers","callbacks":[{"id":"handle_call/3","anchor":"c:handle_call/3"},{"id":"handle_cast/2","anchor":"c:handle_cast/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"init/3","anchor":"c:init/3"}],"functions":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"init/1","anchor":"init/1"},{"id":"start/2","anchor":"start/2"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"stop/1","anchor":"stop/1"}]},{"id":"Scenic.ViewPort.Driver.Config","title":"Scenic.ViewPort.Driver.Config","group":"Drivers","functions":[{"id":"valid!/1","anchor":"valid!/1"},{"id":"valid?/1","anchor":"valid?/1"}]},{"id":"Scenic.ViewPort.Driver.Info","title":"Scenic.ViewPort.Driver.Info","group":"Drivers"},{"id":"Scenic.Cache","title":"Scenic.Cache","group":"Cache","functions":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"claim/2","anchor":"claim/2"},{"id":"fetch/1","anchor":"fetch/1"},{"id":"get!/1","anchor":"get!/1"},{"id":"get/2","anchor":"get/2"},{"id":"init/1","anchor":"init/1"},{"id":"keys/1","anchor":"keys/1"},{"id":"member?/2","anchor":"member?/2"},{"id":"put/3","anchor":"put/3"},{"id":"release/2","anchor":"release/2"},{"id":"request_notification/1","anchor":"request_notification/1"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"status/2","anchor":"status/2"},{"id":"stop_notification/1","anchor":"stop_notification/1"}]},{"id":"Scenic.Cache.File","title":"Scenic.Cache.File","group":"Cache","functions":[{"id":"load/3","anchor":"load/3"},{"id":"read/3","anchor":"read/3"}]},{"id":"Scenic.Cache.Hash","title":"Scenic.Cache.Hash","group":"Cache","functions":[{"id":"binary!/2","anchor":"binary!/2"},{"id":"binary/2","anchor":"binary/2"},{"id":"file!/2","anchor":"file!/2"},{"id":"file/2","anchor":"file/2"},{"id":"from_path/1","anchor":"from_path/1"},{"id":"path_params/1","anchor":"path_params/1"},{"id":"path_params/2","anchor":"path_params/2"},{"id":"path_params/3","anchor":"path_params/3"},{"id":"valid_hash_type!/1","anchor":"valid_hash_type!/1"},{"id":"valid_hash_type?/1","anchor":"valid_hash_type?/1"},{"id":"valid_hash_types/0","anchor":"valid_hash_types/0"},{"id":"verify!/3","anchor":"verify!/3"},{"id":"verify/3","anchor":"verify/3"},{"id":"verify_file!/1","anchor":"verify_file!/1"},{"id":"verify_file/1","anchor":"verify_file/1"}]},{"id":"Scenic.Cache.Term","title":"Scenic.Cache.Term","group":"Cache","functions":[{"id":"load/3","anchor":"load/3"},{"id":"read/3","anchor":"read/3"}]},{"id":"Scenic.Utilities.Enum","title":"Scenic.Utilities.Enum","group":"Utilities","functions":[{"id":"filter_map/2","anchor":"filter_map/2"},{"id":"filter_map_reduce/3","anchor":"filter_map_reduce/3"},{"id":"filter_reduce/3","anchor":"filter_reduce/3"}]},{"id":"Scenic.Utilities.Map","title":"Scenic.Utilities.Map","group":"Utilities","functions":[{"id":"apply_difference/3","anchor":"apply_difference/3"},{"id":"delete_in/2","anchor":"delete_in/2"},{"id":"difference/3","anchor":"difference/3"},{"id":"merge_difference/2","anchor":"merge_difference/2"}]}],"tasks":[{"id":"Mix.Tasks.Scenic.Hash","title":"scenic.hash","group":""},{"id":"Mix.Tasks.Scenic.Run","title":"scenic.run","group":""}]}